"""Test PDF components.
"""
import unittest

from zope.component import getAdapter
from zope.interface import verify
from waeup.sirp.applicants.pdf import IPDF, PDFApplicationSlip
from waeup.sirp.applicants.tests.test_browser import ApplicantsFullSetup
from waeup.sirp.interfaces import IPDF
from waeup.sirp.testing import FunctionalTestCase, FunctionalLayer

class PDFApplicationSlipTests(ApplicantsFullSetup):

    layer = FunctionalLayer

    def test_ifaces(self):
        # make sure we implement/provide the promised interfaces
        obj = PDFApplicationSlip(self.applicant)
        verify.verifyClass(IPDF, PDFApplicationSlip)
        verify.verifyObject(IPDF, obj)
        return

    def test_adapter(self):
        # we can get PDFs by adapter lookup
        pdfcreator = getAdapter(self.applicant, IPDF, name='application_slip')
        self.assertTrue(pdfcreator is not None)
        return

    def test_call(self):
        # we can generate PDFs from applicants
        pdfcreator = PDFApplicationSlip(self.applicant)
        result = pdfcreator()
        self.assertTrue(result.startswith('%PDF-1.4'))
        return

    def test_call_with_admission_set(self):
        # we can generate PDF if admission course is set.
        # XXX: implement test
        pass

    def test_call_with_view(self):
        # we can provide extra info if we have a view
        # XXX: implement test
        pass
